/* Copyright (c) 1997, MpegTV LLC */

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */


#include "mtvp/misc.h"

/*--------------------------------------------------------------------------+
| portable_catch_termination_signals										|
+--------------------------------------------------------------------------*/
void
portable_catch_termination_signals(handler)
	void	(*handler)();
{
	/*
	 * Catch all signals causing process termination.
	 * Signal causing a core dump are not caught, except SIGABRT.
	 */

	/* The following 6 signals are defined by ANSI C */
	(void)signal(SIGABRT, handler);
	(void)signal(SIGINT, handler);
	(void)signal(SIGTERM, handler);
	(void)signal(SIGILL, handler);
	(void)signal(SIGFPE, handler);
	(void)signal(SIGSEGV, handler);

#ifdef _POSIX_SOURCE
	(void)signal(SIGHUP, handler);
#ifndef DEBUG
	(void)signal(SIGQUIT, handler);
#endif /* not DEBUG */
#endif /* _POSIX_SOURCE */

	/*
	 * Implementation dependent signals
	 */
#if defined(ARCH_sun4) || defined(ARCH_sun4gcc)
	(void)signal(SIGTRAP, handler);
	(void)signal(SIGEMT, handler);
#ifndef DEBUG
	(void)signal(SIGSYS, handler);
	(void)signal(SIGLOST, handler);
#endif /* not DEBUG */
	(void)signal(SIGPIPE, handler);
#ifndef PTHREAD
	(void)signal(SIGALRM, handler);
#endif
	(void)signal(SIGXCPU, handler);
	(void)signal(SIGXFSZ, handler);
	(void)signal(SIGVTALRM, handler);
	(void)signal(SIGPROF, handler);
	(void)signal(SIGUSR1, handler);
	(void)signal(SIGUSR2, handler);
#endif /* defined(ARCH_sun4) || defined(ARCH_sun4gcc) */
#if !defined(CONFIG_bsdi)
	(void)signal(SIGBUS, handler);
#endif
}
