/* Copyright (c) 1997, MpegTV LLC */
#ifndef _gamma_h
#define _gamma_h
#ifndef lint
static char rcsid_gamma_h[] = "$Header: /net/hopkins/var/home/tristan/mpeg/dec/RCS/gamma.h,v 1.6 1997/10/21 09:54:17 tristan Exp $";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

#include "mtvp/misc.h"
#include "yuvtorgb.h"

/*--------------------------------------------------------------------------+
| Macros:																	|
+--------------------------------------------------------------------------*/

#if 0 /* Tristan Savatier - Tue Feb 25 14:39:11 PST 1997 */
//#define GAMMA_CORRECTION(x) (Gamma_correct == 1 ? (x) : NINT(pow((x) / 255.0, Gamma_correct) * 255.0))
#endif /* 0 - Tristan Savatier - Tue Feb 25 14:39:11 PST 1997 */

#define GAMMA_CORRECTION(x) gamma_correction(x)

static INLINE u_int
gamma_correction(x)
	u_int	x;
{
	double	d;
	
	d = (Luma_floor + Luma_shift) * 255.0 + x * (1.0 - Luma_floor);
	if (d < 0) {
		d = 0;
	} else if (d > 255) {
		d = 255;
	}
	if (Gamma_correct == 1) {
		return NINT(d);
	}
	
	d = pow(d * (1.0 / 255.0), Gamma_correct) * 255.0;

	return NINT(d);
}

#if 0 /* Tristan Savatier - Tue Feb 25 17:43:22 PST 1997 */
//static INLINE int
//chroma_correction(x)
//	int	x;
//{
//	double	d;
//	
//	if (x >= 0) {
//		d = Luma_floor * 127.0 + x * (1 - Luma_floor);
//	} else {
//		d = - Luma_floor * 127.0 + x * (1 - Luma_floor);
//	}
//	return NINT(d);
//}
#endif /* 0 - Tristan Savatier - Tue Feb 25 17:43:22 PST 1997 */

#if 0 /* Tristan Savatier - Thu Aug 8 13:25:37 PDT 1996 */
//#define GAMMA_CORRECTION(x) (Gamma_correct == 1 ? (FIX_CCIR_RANGE(x)) : NINT(pow((FIX_CCIR_RANGE(x)) / 255.0, 1.0 / Gamma_correct) * 255.0))
#endif /* 0 - Tristan Savatier - Thu Aug 8 13:25:37 PDT 1996 */

#define CHROMA_CORRECTION256(x) (Chroma_correct == 1 ? (x) : ((x) >= 128 \
                        ? 128 + Min(127, (int)(((x) - 128.0) * Chroma_correct)) \
                        : 128 - Min(128, (int)((128.0 - (x)) * Chroma_correct))))
                        
#define CHROMA_CORRECTION128(x) (Chroma_correct == 1 ? (x) : ((x) >= 0 \
                        ? Min(127,  NINT(((x) * Chroma_correct))) \
                        : Max(-128, NINT(((x) * Chroma_correct)))))

#if 0 /* Tristan Savatier - Tue Feb 25 17:43:33 PST 1997 */
//#define CHROMA_CORRECTION128(x) chroma_correction(x)
#endif /* 0 - Tristan Savatier - Tue Feb 25 17:43:33 PST 1997 */
                        
#define CHROMA_CORRECTION256D(x) (Chroma_correct == 1 ? (x) : ((x) >= 128 \
                        ? 128.0 + Min(127.0, (((x) - 128.0) * Chroma_correct)) \
                        : 128.0 - Min(128.0, (((128.0 - (x)) * Chroma_correct)))))
#define CHROMA_CORRECTION128D(x) (Chroma_correct == 1 ? (x) : ((x) >= 0 \
                        ? Min(127.0,  ((x) * Chroma_correct)) \
                        : Max(-128.0, ((x) * Chroma_correct))))

#endif /* _gamma_h */
